> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://next.developer.frame.io/platform/v2/api-reference/projects/batch-create-collaborators/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://next.developer.frame.io/_mcp/server. # Batch create Collaborators and PendingCollaborators within a Project POST https://api.frame.io/v2/batch/projects/{project_id}/collaborators Content-Type: application/json Submit a list of Collaborators to add to the given Project as Collaborators Reference: https://next.developer.frame.io/platform/v2/api-reference/projects/batch-create-collaborators ## Authentication - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Request ### Path parameters - `project_id` (string, required) ### Body (application/json) This endpoint expects a BatchInviteParams. - `batch` (list of BatchInviteParamsBatchItems, optional) - `default_message` (string, optional) — Default invite message to be applied to all invites created - `send_email` (boolean, optional, default: true) — When false no emails will be sent to the new Reviewers and Pending Reviewers ## Response ### 200 Batch create success response - `error` (V2BatchProjectsProjectIdCollaboratorsPostResponsesContentApplicationJsonSchemaError, optional) ## Errors ### 401 Unauthorized Error Unauthorized response - `code` (integer, optional) - `errors` (list of HttpErrorErrorsItems, optional) - `message` (string, optional) ### 404 Not Found Error Not Found response - `code` (integer, optional) - `errors` (list of HttpErrorErrorsItems, optional) - `message` (string, optional) ## Types ### BatchInviteParamsBatchItems - `email` (string, optional) — Create an invite for the given email - `message` (string, optional) — Invite message to be used for this one bath op - `team_id` (string, optional) — Create a set of invites for all approved team members within the given team - `user_group_id` (string, optional) — Create a set of invites for all the users within the given user group - `user_id` (string, optional) — Create an invite for the given user_id ### V2BatchProjectsProjectIdCollaboratorsPostResponsesContentApplicationJsonSchemaError ### HttpErrorErrorsItems - `code` (integer, optional) - `detail` (string, optional) - `status` (integer, optional) - `title` (string, optional) ## Examples ### response **Response** ```json { "error": { "aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa": "Something went wrong!" } } ``` **SDK Code** ```python response import requests url = "https://api.frame.io/v2/batch/projects/project_id/collaborators" headers = {"Authorization": "Bearer "} response = requests.post(url, headers=headers) print(response.json()) ``` ```javascript response const url = 'https://api.frame.io/v2/batch/projects/project_id/collaborators'; const options = {method: 'POST', headers: {Authorization: 'Bearer '}}; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go response package main import ( "fmt" "net/http" "io" ) func main() { url := "https://api.frame.io/v2/batch/projects/project_id/collaborators" req, _ := http.NewRequest("POST", url, nil) req.Header.Add("Authorization", "Bearer ") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby response require 'uri' require 'net/http' url = URI("https://api.frame.io/v2/batch/projects/project_id/collaborators") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = 'Bearer ' response = http.request(request) puts response.read_body ``` ```java response import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.frame.io/v2/batch/projects/project_id/collaborators") .header("Authorization", "Bearer ") .asString(); ``` ```php response request('POST', 'https://api.frame.io/v2/batch/projects/project_id/collaborators', [ 'headers' => [ 'Authorization' => 'Bearer ', ], ]); echo $response->getBody(); ``` ```csharp response using RestSharp; var client = new RestClient("https://api.frame.io/v2/batch/projects/project_id/collaborators"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "Bearer "); IRestResponse response = client.Execute(request); ``` ```swift response import Foundation let headers = ["Authorization": "Bearer "] let request = NSMutableURLRequest(url: NSURL(string: "https://api.frame.io/v2/batch/projects/project_id/collaborators")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ``` ### request_with_default_message **Request** ```json { "batch": [ { "message": "Please review this!", "user_id": "aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa" }, { "user_id": "bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb" }, { "user_group_id": "cccccccc-cccc-cccc-cccc-cccccccccccc" }, { "email": "testing@foobar.biz" } ], "default_message": "Welcome!" } ``` **Response** ```json { "error": { "aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa": "Something went wrong!" } } ``` **SDK Code** ```python request_with_default_message import requests url = "https://api.frame.io/v2/batch/projects/project_id/collaborators" payload = { "batch": [{ "message": "Please review this!", "user_id": "aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa" }, { "user_id": "bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb" }, { "user_group_id": "cccccccc-cccc-cccc-cccc-cccccccccccc" }, { "email": "testing@foobar.biz" }], "default_message": "Welcome!" } headers = { "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript request_with_default_message const url = 'https://api.frame.io/v2/batch/projects/project_id/collaborators'; const options = { method: 'POST', headers: {Authorization: 'Bearer ', 'Content-Type': 'application/json'}, body: '{"batch":[{"message":"Please review this!","user_id":"aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa"},{"user_id":"bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb"},{"user_group_id":"cccccccc-cccc-cccc-cccc-cccccccccccc"},{"email":"testing@foobar.biz"}],"default_message":"Welcome!"}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go request_with_default_message package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.frame.io/v2/batch/projects/project_id/collaborators" payload := strings.NewReader("{\n \"batch\": [\n {\n \"message\": \"Please review this!\",\n \"user_id\": \"aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa\"\n },\n {\n \"user_id\": \"bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb\"\n },\n {\n \"user_group_id\": \"cccccccc-cccc-cccc-cccc-cccccccccccc\"\n },\n {\n \"email\": \"testing@foobar.biz\"\n }\n ],\n \"default_message\": \"Welcome!\"\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby request_with_default_message require 'uri' require 'net/http' url = URI("https://api.frame.io/v2/batch/projects/project_id/collaborators") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "{\n \"batch\": [\n {\n \"message\": \"Please review this!\",\n \"user_id\": \"aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa\"\n },\n {\n \"user_id\": \"bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb\"\n },\n {\n \"user_group_id\": \"cccccccc-cccc-cccc-cccc-cccccccccccc\"\n },\n {\n \"email\": \"testing@foobar.biz\"\n }\n ],\n \"default_message\": \"Welcome!\"\n}" response = http.request(request) puts response.read_body ``` ```java request_with_default_message import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.frame.io/v2/batch/projects/project_id/collaborators") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("{\n \"batch\": [\n {\n \"message\": \"Please review this!\",\n \"user_id\": \"aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa\"\n },\n {\n \"user_id\": \"bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb\"\n },\n {\n \"user_group_id\": \"cccccccc-cccc-cccc-cccc-cccccccccccc\"\n },\n {\n \"email\": \"testing@foobar.biz\"\n }\n ],\n \"default_message\": \"Welcome!\"\n}") .asString(); ``` ```php request_with_default_message request('POST', 'https://api.frame.io/v2/batch/projects/project_id/collaborators', [ 'body' => '{ "batch": [ { "message": "Please review this!", "user_id": "aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa" }, { "user_id": "bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb" }, { "user_group_id": "cccccccc-cccc-cccc-cccc-cccccccccccc" }, { "email": "testing@foobar.biz" } ], "default_message": "Welcome!" }', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp request_with_default_message using RestSharp; var client = new RestClient("https://api.frame.io/v2/batch/projects/project_id/collaborators"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"batch\": [\n {\n \"message\": \"Please review this!\",\n \"user_id\": \"aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa\"\n },\n {\n \"user_id\": \"bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb\"\n },\n {\n \"user_group_id\": \"cccccccc-cccc-cccc-cccc-cccccccccccc\"\n },\n {\n \"email\": \"testing@foobar.biz\"\n }\n ],\n \"default_message\": \"Welcome!\"\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift request_with_default_message import Foundation let headers = [ "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = [ "batch": [[ "message": "Please review this!", "user_id": "aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa" ], ["user_id": "bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb"], ["user_group_id": "cccccccc-cccc-cccc-cccc-cccccccccccc"], ["email": "testing@foobar.biz"]], "default_message": "Welcome!" ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.frame.io/v2/batch/projects/project_id/collaborators")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ``` ### request_without_default_message **Request** ```json { "batch": [ { "message": "Please review this!", "user_id": "aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa" }, { "user_id": "bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb" }, { "user_group_id": "cccccccc-cccc-cccc-cccc-cccccccccccc" }, { "email": "testing@foobar.biz" } ] } ``` **Response** ```json { "error": { "aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa": "Something went wrong!" } } ``` **SDK Code** ```python request_without_default_message import requests url = "https://api.frame.io/v2/batch/projects/project_id/collaborators" payload = { "batch": [{ "message": "Please review this!", "user_id": "aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa" }, { "user_id": "bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb" }, { "user_group_id": "cccccccc-cccc-cccc-cccc-cccccccccccc" }, { "email": "testing@foobar.biz" }] } headers = { "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript request_without_default_message const url = 'https://api.frame.io/v2/batch/projects/project_id/collaborators'; const options = { method: 'POST', headers: {Authorization: 'Bearer ', 'Content-Type': 'application/json'}, body: '{"batch":[{"message":"Please review this!","user_id":"aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa"},{"user_id":"bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb"},{"user_group_id":"cccccccc-cccc-cccc-cccc-cccccccccccc"},{"email":"testing@foobar.biz"}]}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go request_without_default_message package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.frame.io/v2/batch/projects/project_id/collaborators" payload := strings.NewReader("{\n \"batch\": [\n {\n \"message\": \"Please review this!\",\n \"user_id\": \"aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa\"\n },\n {\n \"user_id\": \"bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb\"\n },\n {\n \"user_group_id\": \"cccccccc-cccc-cccc-cccc-cccccccccccc\"\n },\n {\n \"email\": \"testing@foobar.biz\"\n }\n ]\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby request_without_default_message require 'uri' require 'net/http' url = URI("https://api.frame.io/v2/batch/projects/project_id/collaborators") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "{\n \"batch\": [\n {\n \"message\": \"Please review this!\",\n \"user_id\": \"aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa\"\n },\n {\n \"user_id\": \"bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb\"\n },\n {\n \"user_group_id\": \"cccccccc-cccc-cccc-cccc-cccccccccccc\"\n },\n {\n \"email\": \"testing@foobar.biz\"\n }\n ]\n}" response = http.request(request) puts response.read_body ``` ```java request_without_default_message import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.frame.io/v2/batch/projects/project_id/collaborators") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("{\n \"batch\": [\n {\n \"message\": \"Please review this!\",\n \"user_id\": \"aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa\"\n },\n {\n \"user_id\": \"bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb\"\n },\n {\n \"user_group_id\": \"cccccccc-cccc-cccc-cccc-cccccccccccc\"\n },\n {\n \"email\": \"testing@foobar.biz\"\n }\n ]\n}") .asString(); ``` ```php request_without_default_message request('POST', 'https://api.frame.io/v2/batch/projects/project_id/collaborators', [ 'body' => '{ "batch": [ { "message": "Please review this!", "user_id": "aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa" }, { "user_id": "bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb" }, { "user_group_id": "cccccccc-cccc-cccc-cccc-cccccccccccc" }, { "email": "testing@foobar.biz" } ] }', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp request_without_default_message using RestSharp; var client = new RestClient("https://api.frame.io/v2/batch/projects/project_id/collaborators"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"batch\": [\n {\n \"message\": \"Please review this!\",\n \"user_id\": \"aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa\"\n },\n {\n \"user_id\": \"bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb\"\n },\n {\n \"user_group_id\": \"cccccccc-cccc-cccc-cccc-cccccccccccc\"\n },\n {\n \"email\": \"testing@foobar.biz\"\n }\n ]\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift request_without_default_message import Foundation let headers = [ "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = ["batch": [[ "message": "Please review this!", "user_id": "aaaaaaaa-aaaa-aaaa-aaaa-aaaaaaaaaaaa" ], ["user_id": "bbbbbbbb-bbbb-bbbb-bbbb-bbbbbbbbbbbb"], ["user_group_id": "cccccccc-cccc-cccc-cccc-cccccccccccc"], ["email": "testing@foobar.biz"]]] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.frame.io/v2/batch/projects/project_id/collaborators")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```